We now give details about our experimental setup in~\ref{sec:setup},
and present our results in~\ref{sec:results}.

\subsection{Experimental Set Up}
\label{sec:setup}
\input{tex/setup.tex}

\subsection{Experimental Results}
\label{sec:results}

\subsubsection{Impact of multi-threading}

In order to see the impact of the DPU threads, we run experiments with different number of threads, using the three random datasets previously presented.
The runtime is obtained as follows: we measure the number of cycles taken for each DPU and iteration.
We keep the value of the longest DPU, and we sum over the iterations.
Finally, we compute the final runtime as we know DPU frequency is 750 MHz.

Results are given in \figurename~\ref{img:threads}.
We can see the impact of the thread pipeline to ensure minimum latency while accessing memory.
The runtime decreases as the number of threads increases, until reaching a plateau starting at around 8 threads.
Therefore, we set the number of threads to 10 for all remaining experiments.


\begin{figure*}
    \centering
    \subfloat[\textsc{Random-0}]{%
        \includegraphics[width=0.3\textwidth]{threads_DATASET0}
    }
    \subfloat[\textsc{Random-1}]{%
        \includegraphics[width=0.3\textwidth]{threads_DATASET1}
    }
    \subfloat[\textsc{Random-2}]{%
        \includegraphics[width=0.3\textwidth]{threads_DATASET2}
    }
    \caption{DPU runtime for different number of threads with random datasets}
\label{img:threads}
\end{figure*}

\subsubsection{Impact of the number of DPUs}
We now fix a dataset, we chose \textsc{Random-0}, and measure runtime with different numbers of available DPUs.
Results are given in \figurename~\ref{img:nb_dpus}.

As we can see, the dependence is inversely proportional:
if we multiply by two the number of DPUs, the runtime is divided by two.
This result is consistent since the computation time per point is independent from the number of points the DPU has to process.

\begin{figure}
    \centering
    \subfloat[\textsc{Random-1}]{%
        \includegraphics[width=0.5\textwidth]{dpus_DATASET1}
    }
    \caption{DPU runtime for different number of DPUs}
\label{img:nb_dpus}
\end{figure}

\subsubsection{Comparison with Reference Implementation}

We compare our implementation with the C sequential program presented in~\ref{sec:ref_implem}.
We refer to it as SeqC, and to our implementation as X-DPUs, meaning the experiment was conducted using X DPUs.
We consider random datasets previously presented.
Runtime results are summarized in \tablename~\ref{img:random_seqC_comparison}.
Because of the previous results, we can compute the number of DPUs required to be faster than the sequential version.

\begin{table*}
    \centering
    \definecolor{Gray1}{gray}{0.6}
    \definecolor{Gray2}{gray}{0.8}
    \begin{tabular}{|p{0.2\textwidth}|p{0.1\textwidth}|p{0.1\textwidth}|p{0.1\textwidth}|p{0.1\textwidth}|p{0.1\textwidth}|p{0.1\textwidth}|}
    \hline
    \rowcolor{Gray1}
    Dataset & \multicolumn{2}{c|}{\textsc{Random-0}} & \multicolumn{2}{c|}{\textsc{Random-1}} & \multicolumn{2}{c|}{\textsc{Random-2}} \\
    \hline
    \rowcolor{Gray2}
    Algorithm & 16-DPUs & SeqC & 16-DPUs & SeqC & 16-DPUs & SeqC \\
    % \hline
    % Clustering quality: $f(C)$ & 385594590 & 379891255 & 451887191 & 440368024 & 5068367 & 8352228 \\
    \hline
    Runtime (s) & 1.568 & 0.268 & 4.534 & 0.119 & 0.4353 & 0.0142 \\
    % \hline
    % \emph{SpeedUp}(16-DPUs, SeqC) & \multicolumn{2}{c|}{5.85} & \multicolumn{2}{c|}{38.1} & \multicolumn{2}{c|}{30.65} \\
    \hline
    Faster than SeqC with & \multicolumn{2}{c|}{94 DPUs} & \multicolumn{2}{c|}{610 DPUs} & \multicolumn{2}{c|}{491 DPUs} \\
    \hline
    \end{tabular}
    \caption{Comparison with C sequential program on random datasets}
\label{img:random_seqC_comparison}
\end{table*}

As we can see, having a low number of dimensions and centroids is the best case.
This can be explained because a larger number of dimensions requires a larger amount of multiplications per point for the distance computation.
A similar problem occurs with a larger number of centroids that requires a larger amount of computation per memory transfer~\cite{Bender:2015:KCT:2818950.2818977}.
